<?php
/**
 * @package		Easypublish
 * @subpackage	Content.easypublish
 * @copyright	Copyright (C) artd webdesign GmbH. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die ;

class PlgContentEasypublish extends JPlugin
{

	public function onContentPrepare($context, &$article, &$params, $limitstart)
	{
		// if {easypublish}{/easypublish} found
        if (preg_match_all("/{easypublish(.*?)}(.*?){\/easypublish}/i", $article->text, $matches) > 0) {

	        if ( isset( $matches[0] ) && isset( $matches[1] ) && isset( $matches[2] ) && sizeof( $matches[1] ) == sizeof( $matches[2] ) ) {
		        for ( $i = 0; $i < sizeof( $matches[1] ); $i ++ ) {
			        $easypublish_attributes = [];

			        $attributes = array();
			        preg_match_all( '/(\w+)=[\'"]([^\'"]*)/', $matches[1][ $i ], $attributes ); // get attributes from easypublish shortcode, for example "id" and "src"

			        if ( isset( $attributes[1] ) && isset( $attributes[2] ) && is_array( $attributes[1] ) && is_array( $attributes[2] ) && sizeof( $attributes[1] ) == sizeof( $attributes[2] ) ) {
				        for ( $j = 0; $j < sizeof( $attributes[1] ); $j ++ ) {
					        $easypublish_attributes[ $attributes[1][ $j ] ] = $attributes[2][ $j ];
				        }
			        }

			        // generate HTML output
			        $html = '<div class="easypublish-container" data-config="' . $easypublish_attributes['id'] . '"><script src="https://www.' . $easypublish_attributes['src'] . '.ch/assets/js/easypublish/v1/default.js"></script>' . $matches[2][$i] . '</div>';

			        // replace text in article
			        $article->text = str_replace( $matches[0][ $i ], $html, $article->text );
		        }
	        }
        }

		return true;
	}
	
}
